Index: molecuilder/Makefile.am
===================================================================
--- molecuilder/Makefile.am	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -1,4 +1,4 @@
 ACLOCAL_AMFLAGS = -I m4
-SUBDIRS = src src/unittests doc tests 
+SUBDIRS = src src/Actions src/unittests doc tests 
 
 EXTRA_DIST = autogen.sh
Index: molecuilder/configure.ac
===================================================================
--- molecuilder/configure.ac	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/configure.ac	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -94,8 +94,19 @@
 # test suite
 AC_CONFIG_TESTDIR(tests)
-AC_CONFIG_FILES([tests/atlocal tests/Makefile])
-AC_CONFIG_FILES([tests/Tesselations/Makefile tests/Tesselations/defs])
+AC_CONFIG_FILES([
+	tests/atlocal 
+	tests/Makefile])
+AC_CONFIG_FILES([
+	tests/Tesselations/Makefile 
+	tests/Tesselations/defs])
 AC_CONFIG_FILES([tests/molecuilder], [chmod +x tests/molecuilder])
-AC_CONFIG_FILES([doc/molecuilder.xml])
-AC_CONFIG_FILES([Makefile src/Makefile doc/Makefile src/unittests/Makefile])
+AC_CONFIG_FILES([
+	doc/molecuilder.xml])
+AC_CONFIG_FILES([
+	Makefile 
+	doc/Makefile 
+	src/Makefile 
+	src/Actions/Makefile
+	src/UIElements/Makefile
+	src/unittests/Makefile])
 AC_OUTPUT
Index: molecuilder/src/Actions/Makefile.am
===================================================================
--- molecuilder/src/Actions/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/Actions/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,141 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+
+noinst_LIBRARIES = libMolecuilderActions.a
+libMolecuilderActions_a_SOURCES = ${ACTIONSSOURCE} ${ACTIONSHEADER}
+
+ACTIONSSOURCE = \
+  ${ANALYSISACTIONSOURCE} \
+  ${ATOMACTIONSOURCE} \
+  ${CMDACTIONSOURCE} \
+  ${FRAGMENTATIONACTIONSOURCE} \
+  ${MOLECULEACTIONSOURCE} \
+  ${PARSERACTIONSOURCE} \
+  ${TESSELATIONACTIONSOURCE} \
+  ${WORLDACTIONSOURCE} \
+  MapOfActions.cpp
+
+ACTIONSHEADER = \
+  ${ANALYSISACTIONHEADER} \
+  ${ATOMACTIONHEADER} \
+  ${CMDACTIONHEADER} \
+  ${FRAGMENTATIONACTIONHEADER} \
+  ${MOLECULEACTIONHEADER} \
+  ${PARSERACTIONHEADER} \
+  ${TESSELATIONACTIONHEADER} \
+  ${WORLDACTIONHEADER} \
+  MapOfActions.hpp
+  
+ANALYSISACTIONSOURCE = \
+  AnalysisAction/MolecularVolumeAction.cpp \
+  AnalysisAction/PairCorrelationAction.cpp \
+  AnalysisAction/PairCorrelationToPointAction.cpp \
+  AnalysisAction/PairCorrelationToSurfaceAction.cpp \
+  AnalysisAction/PrincipalAxisSystemAction.cpp
+ANALYSISACTIONHEADER = \
+  AnalysisAction/MolecularVolumeAction.hpp \
+  AnalysisAction/PairCorrelationAction.hpp \
+  AnalysisAction/PairCorrelationToPointAction.hpp \
+  AnalysisAction/PairCorrelationToSurfaceAction.hpp \
+  AnalysisAction/PrincipalAxisSystemAction.hpp
+
+ATOMACTIONSOURCE = \
+  AtomAction/AddAction.cpp \
+  AtomAction/ChangeElementAction.cpp \
+  AtomAction/RemoveAction.cpp
+ATOMACTIONHEADER = \
+  AtomAction/AddAction.hpp \
+  AtomAction/ChangeElementAction.hpp \
+  AtomAction/RemoveAction.cpp
+
+CMDACTIONSOURCE = \
+  CmdAction/BondLengthTableAction.cpp \
+  CmdAction/ElementDbAction.cpp \
+  CmdAction/FastParsingAction.cpp \
+  CmdAction/HelpAction.cpp \
+  CmdAction/VerboseAction.cpp \
+  CmdAction/VersionAction.cpp
+CMDACTIONHEADER = \
+  CmdAction/BondLengthTableAction.hpp \
+  CmdAction/ElementDbAction.hpp \
+  CmdAction/FastParsingAction.hpp \
+  CmdAction/HelpAction.hpp \
+  CmdAction/VerboseAction.hpp \
+  CmdAction/VersionAction.hpp
+
+FRAGMENTATIONACTIONSOURCE = \
+  FragmentationAction/DepthFirstSearchAction.cpp \
+  FragmentationAction/FragmentationAction.cpp \
+  FragmentationAction/SubgraphDissectionAction.cpp               
+FRAGMENTATIONACTIONHEADER = \
+  FragmentationAction/DepthFirstSearchAction.hpp \
+  FragmentationAction/FragmentationAction.hpp \
+  FragmentationAction/SubgraphDissectionAction.hpp
+
+MOLECULEACTIONSOURCE = \
+  MoleculeAction/BondFileAction.cpp \
+  MoleculeAction/ChangeNameAction.cpp \
+  MoleculeAction/FillWithMoleculeAction.cpp \
+  MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp \
+  MoleculeAction/RotateToPrincipalAxisSystemAction.cpp \
+  MoleculeAction/SaveAdjacencyAction.cpp \
+  MoleculeAction/SaveBondsAction.cpp \
+  MoleculeAction/SaveTemperatureAction.cpp \
+  MoleculeAction/SuspendInWaterAction.cpp \
+  MoleculeAction/TranslateAction.cpp \
+  MoleculeAction/VerletIntegrationAction.cpp
+MOLECULEACTIONHEADER = \
+  MoleculeAction/BondFileAction.hpp \
+  MoleculeAction/ChangeNameAction.hpp \
+  MoleculeAction/FillWithMoleculeAction.hpp \
+  MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp \
+  MoleculeAction/RotateToPrincipalAxisSystemAction.hpp \
+  MoleculeAction/SaveAdjacencyAction.hpp \
+  MoleculeAction/SaveBondsAction.hpp \
+  MoleculeAction/SaveTemperatureAction.hpp \
+  MoleculeAction/SuspendInWaterAction.hpp \
+  MoleculeAction/TranslateAction.hpp \
+  MoleculeAction/VerletIntegrationAction.hpp
+                 
+PARSERACTIONSOURCE = \
+  ParserAction/LoadXyzAction.cpp \
+  ParserAction/SaveXyzAction.cpp       
+PARSERACTIONHEADER = \
+  ParserAction/LoadXyzAction.hpp \
+  ParserAction/SaveXyzAction.hpp
+
+TESSELATIONACTIONSOURCE = \
+  TesselationAction/ConvexEnvelopeAction.cpp \
+  TesselationAction/NonConvexEnvelopeAction.cpp               
+TESSELATIONACTIONHEADER = \
+  TesselationAction/ConvexEnvelopeAction.hpp \
+  TesselationAction/NonConvexEnvelopeAction.hpp
+
+WORLDACTIONSOURCE = \
+  WorldAction/AddEmptyBoundaryAction.cpp \
+  WorldAction/BoundInBoxAction.cpp \
+  WorldAction/CenterInBoxAction.cpp \
+  WorldAction/CenterOnEdgeAction.cpp \
+  WorldAction/ChangeBoxAction.cpp \
+  WorldAction/RemoveSphereOfAtomsAction.cpp \
+  WorldAction/RepeatBoxAction.cpp \
+  WorldAction/ScaleBoxAction.cpp \
+  WorldAction/SetDefaultNameAction.cpp \
+  WorldAction/SetGaussianBasisAction.cpp               
+WORLDACTIONHEADER = \
+  WorldAction/AddEmptyBoundaryAction.hpp \
+  WorldAction/BoundInBoxAction.hpp \
+  WorldAction/CenterInBoxAction.hpp \
+  WorldAction/CenterOnEdgeAction.hpp \
+  WorldAction/ChangeBoxAction.hpp \
+  WorldAction/RemoveSphereOfAtomsAction.hpp \
+  WorldAction/RepeatBoxAction.hpp \
+  WorldAction/ScaleBoxAction.hpp \
+  WorldAction/SetDefaultNameAction.hpp \
+  WorldAction/SetGaussianBasisAction.hpp
+
Index: molecuilder/src/Actions/MapOfActions.cpp
===================================================================
--- molecuilder/src/Actions/MapOfActions.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/Actions/MapOfActions.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -45,5 +45,5 @@
   DescriptionMap["fill-molecule"] = "fill empty space of box with a filler molecule";
   DescriptionMap["fragment-mol"] = "create for a given molecule into fragments up to given order";
-  DescriptionMap["help"] = "produce help message";
+  DescriptionMap["help"] = "Give this help screen";
   DescriptionMap["linear-interpolate"] = "linear interpolation in discrete steps between start and end position of a molecule";
   DescriptionMap["nonconvex-envelope"] = "create the non-convex envelope for a molecule";
@@ -123,7 +123,7 @@
   ShortFormMap["suspend-in-water"] = "U";
   ShortFormMap["translate-mol"] = "t";
-  ShortFormMap["verbose"] = "V";
+  ShortFormMap["verbose"] = "v";
   ShortFormMap["verlet-integrate"] = "P";
-  ShortFormMap["version"] = "v";
+  ShortFormMap["version"] = "V";
 
   // value types for the actions
Index: molecuilder/src/Helpers/MemDebug.cpp
===================================================================
--- molecuilder/src/Helpers/MemDebug.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/Helpers/MemDebug.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -153,4 +153,5 @@
   // build the entry in front of the space
   Memory::entry_t *entry = (Memory::entry_t*) res;
+  memset(res,0,entrySpace);
   entry->info.nbytes = nbytes;
   entry->info.isUsed = true;
Index: molecuilder/src/Makefile.am
===================================================================
--- molecuilder/src/Makefile.am	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/Makefile.am	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -1,4 +1,6 @@
 # PLEASE adhere to the alphabetical ordering in this Makefile!
 # Also indentation by a single tab
+
+SUBDIRS = Actions UIElements
 
 # this includes source files that need to be present at multiple points
@@ -49,13 +51,6 @@
   analysis_correlation.hpp
 
-ACTIONSSOURCE = Actions/Action.cpp \
-  ${ANALYSISACTIONSOURCE} \
-  ${ATOMACTIONSOURCE} \
-  ${CMDACTIONSOURCE} \
-  ${FRAGMENTATIONACTIONSOURCE} \
-  ${MOLECULEACTIONSOURCE} \
-  ${PARSERACTIONSOURCE} \
-  ${TESSELATIONACTIONSOURCE} \
-  ${WORLDACTIONSOURCE} \
+ACTIONSSOURCE = \
+  Actions/Action.cpp \
   Actions/ActionHistory.cpp \
   Actions/ActionRegistry.cpp \
@@ -64,9 +59,8 @@
   Actions/MakroAction.cpp \
   Actions/ManipulateAtomsProcess.cpp \
-  Actions/MapOfActions.cpp \
   Actions/MethodAction.cpp \
   Actions/Process.cpp
 
-ACTIONSHEADER = Actions/Action.hpp \
+ACTIONSHEADER = \
   ${ANALYSISACTIONHEADER} \
   ${ATOMACTIONHEADER} \
@@ -77,4 +71,5 @@
   ${TESSELATIONACTIONHEADER} \
   ${WORLDACTIONHEADER} \
+  Actions/Action.hpp \
   Actions/ActionHistory.hpp \
   Actions/ActionRegistry.hpp \
@@ -89,113 +84,4 @@
   Actions/Process.hpp
   
-ANALYSISACTIONSOURCE = \
-  Actions/AnalysisAction/MolecularVolumeAction.cpp \
-  Actions/AnalysisAction/PairCorrelationAction.cpp \
-  Actions/AnalysisAction/PairCorrelationToPointAction.cpp \
-  Actions/AnalysisAction/PairCorrelationToSurfaceAction.cpp \
-  Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
-ANALYSISACTIONHEADER = \
-  Actions/AnalysisAction/MolecularVolumeAction.hpp \
-  Actions/AnalysisAction/PairCorrelationAction.hpp \
-  Actions/AnalysisAction/PairCorrelationToPointAction.hpp \
-  Actions/AnalysisAction/PairCorrelationToSurfaceAction.hpp \
-  Actions/AnalysisAction/PrincipalAxisSystemAction.hpp
-
-ATOMACTIONSOURCE = \
-  Actions/AtomAction/AddAction.cpp \
-  Actions/AtomAction/ChangeElementAction.cpp \
-  Actions/AtomAction/RemoveAction.cpp
-ATOMACTIONHEADER = \
-  Actions/AtomAction/AddAction.hpp \
-  Actions/AtomAction/ChangeElementAction.hpp \
-  Actions/AtomAction/RemoveAction.cpp
-
-CMDACTIONSOURCE = \
-  Actions/CmdAction/BondLengthTableAction.cpp \
-  Actions/CmdAction/ElementDbAction.cpp \
-  Actions/CmdAction/FastParsingAction.cpp \
-  Actions/CmdAction/HelpAction.cpp \
-  Actions/CmdAction/VerboseAction.cpp \
-  Actions/CmdAction/VersionAction.cpp
-CMDACTIONHEADER = \
-  Actions/CmdAction/BondLengthTableAction.hpp \
-  Actions/CmdAction/ElementDbAction.hpp \
-  Actions/CmdAction/FastParsingAction.hpp \
-  Actions/CmdAction/HelpAction.hpp \
-  Actions/CmdAction/VerboseAction.hpp \
-  Actions/CmdAction/VersionAction.hpp
-
-FRAGMENTATIONACTIONSOURCE = \
-  Actions/FragmentationAction/DepthFirstSearchAction.cpp \
-  Actions/FragmentationAction/FragmentationAction.cpp \
-  Actions/FragmentationAction/SubgraphDissectionAction.cpp               
-FRAGMENTATIONACTIONHEADER = \
-  Actions/FragmentationAction/DepthFirstSearchAction.hpp \
-  Actions/FragmentationAction/FragmentationAction.hpp \
-  Actions/FragmentationAction/SubgraphDissectionAction.hpp
-
-MOLECULEACTIONSOURCE = \
-  Actions/MoleculeAction/BondFileAction.cpp \
-  Actions/MoleculeAction/ChangeNameAction.cpp \
-  Actions/MoleculeAction/FillWithMoleculeAction.cpp \
-  Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.cpp \
-  Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.cpp \
-  Actions/MoleculeAction/SaveAdjacencyAction.cpp \
-  Actions/MoleculeAction/SaveBondsAction.cpp \
-  Actions/MoleculeAction/SaveTemperatureAction.cpp \
-  Actions/MoleculeAction/SuspendInWaterAction.cpp \
-  Actions/MoleculeAction/TranslateAction.cpp \
-  Actions/MoleculeAction/VerletIntegrationAction.cpp
-MOLECULEACTIONHEADER = \
-  Actions/MoleculeAction/BondFileAction.hpp \
-  Actions/MoleculeAction/ChangeNameAction.hpp \
-  Actions/MoleculeAction/FillWithMoleculeAction.hpp \
-  Actions/MoleculeAction/LinearInterpolationofTrajectoriesAction.hpp \
-  Actions/MoleculeAction/RotateToPrincipalAxisSystemAction.hpp \
-  Actions/MoleculeAction/SaveAdjacencyAction.hpp \
-  Actions/MoleculeAction/SaveBondsAction.hpp \
-  Actions/MoleculeAction/SaveTemperatureAction.hpp \
-  Actions/MoleculeAction/SuspendInWaterAction.hpp \
-  Actions/MoleculeAction/TranslateAction.hpp \
-  Actions/MoleculeAction/VerletIntegrationAction.hpp
-                 
-PARSERACTIONSOURCE = \
-  Actions/ParserAction/LoadXyzAction.cpp \
-  Actions/ParserAction/SaveXyzAction.cpp       
-PARSERACTIONHEADER = \
-  Actions/ParserAction/LoadXyzAction.hpp \
-  Actions/ParserAction/SaveXyzAction.hpp
-
-TESSELATIONACTIONSOURCE = \
-  Actions/TesselationAction/ConvexEnvelopeAction.cpp \
-  Actions/TesselationAction/NonConvexEnvelopeAction.cpp               
-TESSELATIONACTIONHEADER = \
-  Actions/TesselationAction/ConvexEnvelopeAction.hpp \
-  Actions/TesselationAction/NonConvexEnvelopeAction.hpp
-
-WORLDACTIONSOURCE = \
-  Actions/WorldAction/AddEmptyBoundaryAction.cpp \
-  Actions/WorldAction/BoundInBoxAction.cpp \
-  Actions/WorldAction/CenterInBoxAction.cpp \
-  Actions/WorldAction/CenterOnEdgeAction.cpp \
-  Actions/WorldAction/ChangeBoxAction.cpp \
-  Actions/WorldAction/RemoveSphereOfAtomsAction.cpp \
-  Actions/WorldAction/RepeatBoxAction.cpp \
-  Actions/WorldAction/ScaleBoxAction.cpp \
-  Actions/WorldAction/SetDefaultNameAction.cpp \
-  Actions/WorldAction/SetGaussianBasisAction.cpp               
-WORLDACTIONHEADER = \
-  Actions/WorldAction/AddEmptyBoundaryAction.hpp \
-  Actions/WorldAction/BoundInBoxAction.hpp \
-  Actions/WorldAction/CenterInBoxAction.hpp \
-  Actions/WorldAction/CenterOnEdgeAction.hpp \
-  Actions/WorldAction/ChangeBoxAction.hpp \
-  Actions/WorldAction/RemoveSphereOfAtomsAction.hpp \
-  Actions/WorldAction/RepeatBoxAction.hpp \
-  Actions/WorldAction/ScaleBoxAction.hpp \
-  Actions/WorldAction/SetDefaultNameAction.hpp \
-  Actions/WorldAction/SetGaussianBasisAction.hpp
-
-
 
 PARSERSOURCE = \
@@ -216,77 +102,4 @@
   Patterns/Observer.hpp \
   Patterns/Singleton.hpp
-
-# Below is all for the User Interface
-
-VIEWSOURCE = \
-  Views/View.cpp \
-  Views/StringView.cpp \
-  Views/MethodStringView.cpp \
-  Views/StreamStringView.cpp
-VIEWHEADER = \
-  Views/View.hpp \
-  Views/StringView.hpp \
-  Views/MethodStringView.hpp \
-  Views/StreamStringView.hpp
-
-MENUSOURCE = \
-  Menu/Menu.cpp \
-  Menu/TextMenu.cpp \
-  Menu/MenuItem.cpp \
-  Menu/SubMenuItem.cpp \
-  Menu/ActionMenuItem.cpp \
-  Menu/SeperatorItem.cpp \
-  Menu/DisplayMenuItem.cpp
-  
-MENUHEADER = \
-  Menu/Menu.hpp \
-  Menu/TextMenu.hpp \
-  Menu/MenuItem.hpp \
-  Menu/SubMenuItem.hpp \
-  Menu/ActionMenuItem.hpp \
-  Menu/SeperatorItem.hpp \
-  Menu/DisplayMenuItem.hpp
-
-UISOURCE = \
-  ${ACTIONSSOURCE} \
-  ${COMMANDLINEUISOURCE} \
-  ${MENUSOURCE} \
-  ${TEXTUISOURCE} \
-  ${VIEWSOURCE} \
-  UIElements/Dialog.cpp \
-  UIElements/MainWindow.cpp \
-  UIElements/UIFactory.cpp
-  
-UIHEADER = \
-  ${ACTIONSHEADER} \
-  ${COMMANDLINEUIHEADER} \
-  ${MENUHEADER} \
-  ${TEXTUIHEADER} \
-  ${VIEWHEADER} \
-  UIElements/Dialog.hpp \
-  UIElements/MainWindow.hpp \
-  UIElements/UIFactory.hpp
-
-TEXTUISOURCE = \
-  UIElements/TextDialog.cpp \
-  UIElements/TextStatusIndicator.cpp \
-  UIElements/TextUIFactory.cpp \
-  UIElements/TextWindow.cpp
-TEXTUIHEADER = \
-  UIElements/TextDialog.hpp \
-  UIElements/TextStatusIndicator.hpp \
-  UIElements/TextUIFactory.hpp \
-  UIElements/TextWindow.hpp
-
-COMMANDLINEUISOURCE = \
-  UIElements/CommandLineDialog.cpp \
-  UIElements/CommandLineStatusIndicator.cpp \
-  UIElements/CommandLineUIFactory.cpp \
-  UIElements/CommandLineWindow.cpp
-COMMANDLINEUIHEADER = \
-  UIElements/CommandLineDialog.hpp \
-  UIElements/CommandLineStatusIndicator.hpp \
-  UIElements/CommandLineUIFactory.hpp \
-  UIElements/CommandLineWindow.hpp
 
 # all these files are only used for legacy reasons while the transition is in progress
@@ -321,8 +134,8 @@
 SOURCE = \
   ${ANALYSISSOURCE} \
+  ${ACTIONSSOURCE} \
   ${ATOMSOURCE} \
   ${PATTERNSOURCE} \
   ${PARSERSOURCE} \
-  ${UISOURCE} \
   ${DESCRIPTORSOURCE} \
   ${HELPERSOURCE} \
@@ -335,4 +148,5 @@
   config.cpp \
   element.cpp \
+  elements_db.cpp \
   ellipsoid.cpp \
   errorlogger.cpp \
@@ -366,8 +180,8 @@
 HEADER = \
   ${ANALYSISHEADER} \
+  ${ACTIONSHEADER} \
   ${ATOMHEADER} \
   ${PARSERHEADER} \
   ${PATTERNHEADER} \
-  ${UIHEADER} \
   ${DESCRIPTORHEADER} \
   ${EXCEPTIONHEADER} \
@@ -380,4 +194,5 @@
   defs.hpp \
   element.hpp \
+  elements_db.hpp \
   ellipsoid.hpp \
   errorlogger.hpp \
@@ -407,5 +222,5 @@
 
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
-INCLUDES = -I$(top_srcdir)/src/unittests
+INCLUDES = -I$(top_srcdir)/src/unittests -I$(top_srcdir)/src/Actions -I$(top_srcdir)/src/UIElements
 
 noinst_LIBRARIES = libmolecuilder.a libgslwrapper.a
@@ -414,8 +229,7 @@
 libmolecuilder_a_SOURCES = ${SOURCE} ${HEADER}
 libgslwrapper_a_SOURCES = ${LINALGSOURCE} ${LINALGHEADER}
-molecuilder_DATA = elements.db valence.db orbitals.db Hbonddistance.db Hbondangle.db
 molecuilder_LDFLAGS = $(BOOST_LDFLAGS)
 molecuilder_SOURCES = builder.cpp
-molecuilder_LDADD = libmolecuilder.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB}
+molecuilder_LDADD =  UIElements/libMolecuilderUI.a Actions/libMolecuilderActions.a libmolecuilder.a libgslwrapper.a $(BOOST_LIB) ${BOOST_THREAD_LIB} ${BOOST_PROGRAM_OPTIONS_LIB} 
 joiner_SOURCES = joiner.cpp datacreator.cpp parser.cpp datacreator.hpp helpers.hpp parser.hpp periodentafel.hpp
 joiner_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
Index: molecuilder/src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,259 @@
+/*
+ * CommandLineDialog.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+
+#include <cassert>
+#include <iostream>
+
+#include <Descriptors/AtomDescriptor.hpp>
+#include <Descriptors/AtomIdDescriptor.hpp>
+#include <Descriptors/MoleculeDescriptor.hpp>
+#include <Descriptors/MoleculeIdDescriptor.hpp>
+#include "CommandLineUI/CommandLineDialog.hpp"
+
+#include "element.hpp"
+#include "periodentafel.hpp"
+#include "CommandLineParser.hpp"
+#include "defs.hpp"
+#include "log.hpp"
+#include "periodentafel.hpp"
+#include "verbose.hpp"
+#include "World.hpp"
+
+#include "atom.hpp"
+#include "element.hpp"
+#include "molecule.hpp"
+#include "vector.hpp"
+
+using namespace std;
+
+
+CommandLineDialog::CommandLineDialog()
+{
+}
+
+CommandLineDialog::~CommandLineDialog()
+{
+}
+
+
+void CommandLineDialog::queryEmpty(const char* title, string _description){
+  registerQuery(new EmptyCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryInt(const char* title, int* target, string _description){
+  registerQuery(new IntCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryBoolean(const char* title, bool* target, string _description){
+  registerQuery(new BooleanCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryDouble(const char* title, double* target, string _description){
+  registerQuery(new DoubleCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryString(const char* title, string* target, string _description){
+  registerQuery(new StringCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryAtom(const char* title, atom **target, string _description) {
+  registerQuery(new AtomCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryMolecule(const char* title, molecule **target, string _description) {
+  registerQuery(new MoleculeCommandLineQuery(title,target, _description));
+}
+
+void CommandLineDialog::queryVector(const char* title, Vector *target,const double *const cellSize, bool check, string _description) {
+  registerQuery(new VectorCommandLineQuery(title,target,cellSize,check, _description));
+}
+
+void CommandLineDialog::queryBox(const char* title, double ** const cellSize, string _description) {
+  registerQuery(new BoxCommandLineQuery(title,cellSize,_description));
+}
+
+void CommandLineDialog::queryElement(const char* title, const element **target, string _description){
+  registerQuery(new ElementCommandLineQuery(title,target, _description));
+}
+
+/************************** Query Infrastructure ************************/
+
+CommandLineDialog::EmptyCommandLineQuery::EmptyCommandLineQuery(string title, string _description) :
+    Dialog::EmptyQuery(title, _description)
+{}
+
+CommandLineDialog::EmptyCommandLineQuery::~EmptyCommandLineQuery() {}
+
+bool CommandLineDialog::EmptyCommandLineQuery::handle() {
+  cout << "Message of " << getTitle() << ":\n" << getDescription() << "\n";
+  return true;
+}
+
+CommandLineDialog::IntCommandLineQuery::IntCommandLineQuery(string title,int *_target, string _description) :
+    Dialog::IntQuery(title,_target, _description)
+{}
+
+CommandLineDialog::IntCommandLineQuery::~IntCommandLineQuery() {}
+
+bool CommandLineDialog::IntCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::BooleanCommandLineQuery::BooleanCommandLineQuery(string title,bool *_target, string _description) :
+    Dialog::BooleanQuery(title,_target, _description)
+{}
+
+CommandLineDialog::BooleanCommandLineQuery::~BooleanCommandLineQuery() {}
+
+bool CommandLineDialog::BooleanCommandLineQuery::handle() {
+  bool badInput = false;
+  char input = ' ';
+  do{
+    badInput = false;
+    Log() << Verbose(0) << getTitle();
+    cin >> input;
+    if ((input == 'y' ) || (input == 'Y')) {
+      tmp = true;
+    } else if ((input == 'n' ) || (input == 'N')) {
+      tmp = false;
+    } else {
+      badInput=true;
+      cin.clear();
+      cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+      Log() << Verbose(0) << "Input was not of [yYnN]!" << endl;
+    }
+  } while(badInput);
+  // clear the input buffer of anything still in the line
+  cin.ignore(std::numeric_limits<streamsize>::max(),'\n');
+  return true;
+}
+
+CommandLineDialog::StringCommandLineQuery::StringCommandLineQuery(string title,string *_target, string _description) :
+    Dialog::StringQuery(title,_target, _description)
+{}
+
+CommandLineDialog::StringCommandLineQuery::~StringCommandLineQuery() {}
+
+bool CommandLineDialog::StringCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<string>();
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::DoubleCommandLineQuery::DoubleCommandLineQuery(string title,double *_target, string _description) :
+    Dialog::DoubleQuery(title,_target, _description)
+{}
+
+CommandLineDialog::DoubleCommandLineQuery::~DoubleCommandLineQuery() {}
+
+bool CommandLineDialog::DoubleCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as<double>();
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::AtomCommandLineQuery::AtomCommandLineQuery(string title, atom **_target, string _description) :
+    Dialog::AtomQuery(title,_target, _description)
+{}
+
+CommandLineDialog::AtomCommandLineQuery::~AtomCommandLineQuery() {}
+
+bool CommandLineDialog::AtomCommandLineQuery::handle() {
+  int IdxOfAtom = -1;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfAtom = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp = World::getInstance().getAtom(AtomById(IdxOfAtom));
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::MoleculeCommandLineQuery::MoleculeCommandLineQuery(string title, molecule **_target, string _description) :
+    Dialog::MoleculeQuery(title,_target, _description)
+{}
+
+CommandLineDialog::MoleculeCommandLineQuery::~MoleculeCommandLineQuery() {}
+
+bool CommandLineDialog::MoleculeCommandLineQuery::handle() {
+  int IdxOfMol = -1;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    IdxOfMol = CommandLineParser::getInstance().vm[getTitle()].as<int>();
+    tmp = World::getInstance().getMolecule(MoleculeById(IdxOfMol));
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::VectorCommandLineQuery::VectorCommandLineQuery(string title, Vector *_target, const double *const _cellSize, bool _check, string _description) :
+    Dialog::VectorQuery(title,_target,_cellSize,_check, _description)
+{}
+
+CommandLineDialog::VectorCommandLineQuery::~VectorCommandLineQuery()
+{}
+
+bool CommandLineDialog::VectorCommandLineQuery::handle() {
+  vector<double> temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as<vector<double> >();
+    assert((temp.size() == 3) && "Vector from command line does not have three components.");
+    for (int i=0;i<NDIM;i++)
+      tmp->at(i) = temp[i];
+    return true;
+  } else
+    return false;
+}
+
+
+CommandLineDialog::BoxCommandLineQuery::BoxCommandLineQuery(string title, double ** const _cellSize, string _description) :
+    Dialog::BoxQuery(title,_cellSize, _description)
+{}
+
+CommandLineDialog::BoxCommandLineQuery::~BoxCommandLineQuery()
+{}
+
+bool CommandLineDialog::BoxCommandLineQuery::handle() {
+  vector<double> temp;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    temp = CommandLineParser::getInstance().vm[getTitle()].as<vector<double> >();
+    assert((temp.size() == 6) && "Symmetric box matrix from command line does not have six components.");
+    for (int i=0;i<6;i++)
+      tmp[i] = temp[i];
+    return true;
+  } else
+    return false;
+}
+
+CommandLineDialog::ElementCommandLineQuery::ElementCommandLineQuery(string title, const element **target, string _description) :
+    Dialog::ElementQuery(title,target, _description)
+{}
+
+CommandLineDialog::ElementCommandLineQuery::~ElementCommandLineQuery()
+{}
+
+bool CommandLineDialog::ElementCommandLineQuery::handle() {
+  // TODO: vector of ints and removing first is not correctly implemented yet. How to remove from a vector?
+  int Z;
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    vector<int> AllElements = CommandLineParser::getInstance().vm[getTitle()].as< vector<int> >();
+    vector<int>::iterator ElementRunner = AllElements.begin();
+    Z = *ElementRunner;
+    // TODO: So far, this does not really erase the element in the parsed list.
+    AllElements.erase(ElementRunner);
+    tmp = World::getInstance().getPeriode()->FindElement(Z);
+    return true;
+  } else
+    return false;
+}
Index: molecuilder/src/UIElements/CommandLineUI/CommandLineDialog.hpp
===================================================================
--- molecuilder/src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
+++ molecuilder/src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -0,0 +1,113 @@
+/*
+ * CommandLineDialog.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEDIALOG_HPP_
+#define COMMANDLINEDIALOG_HPP_
+
+#include <string>
+
+class atom;
+class element;
+class molecule;
+class Vector;
+
+#include "Dialog.hpp"
+
+/** CommandLineUIFactory implementation of the Dialog.
+ * The idea here is that for each query the parsed command line options are used instead.
+ */
+class CommandLineDialog : public Dialog
+{
+public:
+  CommandLineDialog();
+  virtual ~CommandLineDialog();
+
+  virtual void queryEmpty(const char *, std::string = "");
+  virtual void queryInt(const char *, int *, std::string = "");
+  virtual void queryBoolean(const char *, bool *, std::string = "");
+  virtual void queryString(const char*, std::string *, std::string = "");
+  virtual void queryDouble(const char*, double*, std::string = "");
+  virtual void queryAtom(const char*,atom**, std::string = "");
+  virtual void queryMolecule(const char*,molecule**,std::string = "");
+  virtual void queryVector(const char*,Vector *,const double * const,bool, std::string = "");
+  virtual void queryBox(const char*,double ** const, std::string = "");
+  virtual void queryElement(const char*,const element **, std::string = "");
+
+protected:
+  // specialized stuff for text queries
+  class EmptyCommandLineQuery : public Dialog::EmptyQuery {
+  public:
+    EmptyCommandLineQuery(std::string title, std::string _description = "");
+    virtual ~EmptyCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class IntCommandLineQuery : public Dialog::IntQuery {
+  public:
+    IntCommandLineQuery(std::string title, int *_target, std::string _description = "");
+    virtual ~IntCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class BooleanCommandLineQuery : public Dialog::BooleanQuery {
+  public:
+    BooleanCommandLineQuery(std::string title, bool *_target, std::string _description = "");
+    virtual ~BooleanCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class DoubleCommandLineQuery : public Dialog::DoubleQuery {
+  public:
+    DoubleCommandLineQuery(std::string title, double *_target, std::string _description = "");
+    virtual ~DoubleCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class StringCommandLineQuery : public Dialog::StringQuery {
+  public:
+    StringCommandLineQuery(std::string title, std::string *_target, std::string _description = "");
+    virtual ~StringCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class AtomCommandLineQuery : public Dialog::AtomQuery {
+  public:
+    AtomCommandLineQuery(std::string title, atom **_target, std::string _description = "");
+    virtual ~AtomCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class MoleculeCommandLineQuery : public Dialog::MoleculeQuery {
+  public:
+    MoleculeCommandLineQuery(std::string title, molecule **_target, std::string _description = "");
+    virtual ~MoleculeCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class VectorCommandLineQuery : public Dialog::VectorQuery {
+  public:
+    VectorCommandLineQuery(std::string title,Vector *_target,const double *const _cellSize,bool _check, std::string _description = "");
+    virtual ~VectorCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class BoxCommandLineQuery : public Dialog::BoxQuery {
+  public:
+    BoxCommandLineQuery(std::string title,double ** const _cellSize, std::string _description = "");
+    virtual ~BoxCommandLineQuery();
+    virtual bool handle();
+  };
+
+  class ElementCommandLineQuery : public Dialog::ElementQuery {
+  public:
+    ElementCommandLineQuery(std::string title, const element **_target, std::string _description = "");
+    virtual ~ElementCommandLineQuery();
+    virtual bool handle();
+  };
+};
+
+#endif /* COMMANDLINEDIALOG_HPP_ */
